/*
TASK:cube
LANG:C++
*/

#include<iostream>
#include<string>
#include<vector>
#include<map>
#include<cmath>
#include<algorithm>
#include<queue>

#define mv 100000
#define fr(i,s,n) for(i=s;i<=n;i++)
#define v(a) scanf("%d",&a)
#define i(a) printf("%d",a)
#define nr printf("\n")
#define interval printf(" ")
#define check cout<<"---"<<endl

using namespace std;

struct vryh
{
    int x,y,z,w,v,u;
    int k,l,sum;
    bool used[70];
};

queue<vryh>q;
int minsum;
bool dl[16][16];
int oj[16][16];
 
void bfs(int a,int b,int c,int d,int x,int y,int z,int w,int v,int u)
{
    vryh zapaz;
    zapaz.sum=-1;
    vryh uf,l,of;
    uf.x=x;uf.y=y;uf.z=z;uf.w=w;uf.v=v;uf.u=u;uf.k=a;uf.l=b;uf.sum=0;
    int i,nivo=1;
    for(i=1;i<=64;i++)uf.used[i]=0;
    uf.used[(uf.k-1)*8+uf.l]=1;
    q.push(uf);
    q.push(zapaz);
    oj[uf.k][uf.l]=1;
    while(!q.empty())
    {
        l=q.front();//cout<<l.k<<' '<<l.l<<' '<<l.sum<<endl;system("pause");
        q.pop();
        if(l.sum==-1 && q.empty())break;
        if(l.sum==-1){q.push(zapaz);nivo++;continue;}
        if(l.k==c && l.l==d)
        {
            minsum=l.sum;
            while(!q.empty())
            {
                l=q.front();
                if(l.sum==-1)break;
                q.pop();
            }
            return;
        }
        //nadqsno
        if(l.l<8 && !l.used[(l.k-1)*8+l.l+1] && !dl[l.k][l.l+1] && (!oj[l.k][l.l+1] || (oj[l.k][l.l+1]==nivo)))
        {
            of.x=l.x;
            of.y=l.y;
            of.z=l.u;
            of.w=l.z;
            of.v=l.w;
            of.u=l.v;
            of.k=l.k;of.l=l.l+1;of.sum=l.sum+l.w;for(i=1;i<=64;i++)of.used[i]=uf.used[i];
            of.used[(l.k-1)*8+l.l+1]=1;
            q.push(of);
            oj[l.k][l.l+1]=nivo;
        }
        //nalqvo
        if(l.l>1 && !l.used[(l.k-1)*8+l.l-1] && !dl[l.k][l.l-1] && (!oj[l.k][l.l-1] || (oj[l.k][l.l-1]==nivo)))
        {
            of.x=l.x;
            of.y=l.y;
            of.z=l.w;
            of.w=l.v;
            of.v=l.u;
            of.u=l.z;
            of.k=l.k;of.l=l.l-1;of.sum=l.sum+l.u;for(i=1;i<=64;i++)of.used[i]=uf.used[i];
            of.used[(l.k-1)*8+l.l-1]=1;
            q.push(of);
            oj[l.k][l.l-1]=nivo;
        }
        //nagore
        //if(l.k==2 && l.l==6 && nivo==2)cout<<l.used.a[(l.k)*8+l.l]<<endl;
        if(l.k<8 && !l.used[(l.k)*8+l.l] && !dl[l.k+1][l.l] && (!oj[l.k+1][l.l] || (oj[l.k+1][l.l]==nivo)))
        {
            of.x=l.v;
            of.y=l.z;
            of.z=l.x;
            of.w=l.w;
            of.v=l.y;
            of.u=l.u;
            of.k=l.k+1;of.l=l.l;of.sum=l.sum+l.y;for(i=1;i<=64;i++)of.used[i]=uf.used[i];
            of.used[(l.k)*8+l.l]=1;
            q.push(of);
            oj[l.k+1][l.l]=nivo;
        }
        //nadolu
        if(l.k>1 && !l.used[(l.k-2)*8+l.l] && !dl[l.k-1][l.l] && (!oj[l.k-1][l.l] || (oj[l.k-1][l.l]==nivo)))
        {
            of.x=l.z;
            of.y=l.v;
            of.z=l.y;
            of.w=l.w;
            of.v=l.x;
            of.u=l.u;
            of.k=l.k-1;of.l=l.l;of.sum=l.sum+l.x;for(i=1;i<=64;i++)of.used[i]=uf.used[i];
            of.used[(l.k-2)*8+l.l]=1;
            q.push(of);
            oj[l.k-1][l.l]=nivo;
        }
    }
}

int main()
{
    int i,n,x,y,z,w,v,u,a,b,c,d,h,f;
    char t,o;
    scanf("%c",&t);
    a=(int)t-'a'+1;
    v(b);
    scanf("%c",&o);
    scanf("%c",&o);
    c=(int)o-'a'+1;
    v(d);
    v(x);v(y);v(z);v(w);v(v);v(u);
    v(n);
    for(i=1;i<=n;i++)
    {
        scanf("%c",&t);
        scanf("%c",&t);
        h=(int)t-'a'+1;
        v(f);
        dl[f][h]=1;
    }
    bfs(b,a,d,c,x,y,z,w,v,u);
    i(minsum);
    nr;
    return 0;
}
